'-----------------------------------------------------------------------------------------

'name                     : AT-Keyboard_V1.1.bas

'purpose                  : AT-KEYBOARD connected via parallel bus with strobe

'micro                    : Mega88

'In diesem Beispiel mit dem ATMEGA8 ist die PS/2 Tastatur mit Clock an Port D.2 und Data an Port D.0 angeschlossen
'Nach dem Empfang eines Zeichens von der Tastatur werden die Bits der Variablen "key" an die Ausgabeports C.0 - C.5 und B.1 angelegt
'und ein 2ms Strobe generiert. Die Datenbits bleiben noch 100ms angelegt. Das LCD-Display ist nur zum Debuggen implementiert.

'-----------------------------------------------------------------------------------------
' Angepat fr den LLC2 von Manfred Krger

'-----------------------------------------------------------------------------------------



$regfile = "m88def.dat"

$crystal = 8000000                                          '3686400

$hwstack = 128

$swstack = 64

$framesize = 64

Config Pinb.0 = Output
Config Pinb.1 = Output
Config Pinc.0 = Output
Config Pinc.1 = Output
Config Pinc.2 = Output
Config Pinc.3 = Output
Config Pinc.4 = Output
Config Pinc.5 = Output
Config Pind.5 = Output
Config Pind.6 = Output
Config Pind.7 = Output

Kb_strobe Alias Portb.0                                     'Datenbit 7
Kb_d0 Alias Portc.0                                         'Datenbit 0
Kb_d1 Alias Portc.1
Kb_d2 Alias Portc.2
Kb_d3 Alias Portc.3
Kb_d4 Alias Portc.4
Kb_d5 Alias Portc.5
Kb_d6 Alias Portb.1                                         'Datenbit 6


'Config Keyboard = Pind.1 , Data = Pind.0 , Keydata = Keydata  ' alt
Config Keyboard = Pind.2 , Data = Pind.0 , Keydata = Keydata

'Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
'Config Lcd = 16 * 2

Dim Key As Byte
Dim Capslock As Bit
Dim H As Byte
Dim I As Integer
Declare Sub Taste
Declare Sub Ausgabe
Declare Sub Ausgabe1
'Cls
'Locate 1 , 1
'Lcd "AT-Keyboard Ctrl 1.1"
Portd.5 = 0
Portd.6 = 0
Portd.7 = 0
'------------------------------------------------------------------------------
Do

Taste

Loop

End
'-------------------------------------------------------------------------------
' Sub  Hauptprogrammm
Sub Taste

Do

   Key = Getatkbd()


 ' RST,NMI, Grafik Taste zurcksetzen

  Portd.5 = 0
  Portd.6 = 0
  Portd.7 = 0


Loop Until Key <> 0

If Key = 28 Then                                            ' NMI Taste
     Portd.5 = 1
     Ausgabe1
     Portd.5 = 0
     Key = 95
     Ausgabe
     Key = 13
End If
If Key = 25 Then                                            ' RST Taste
     Portd.6 = 1
     Ausgabe1
     Portd.6 = 0
End If
If Key = 18 Then                                            ' Grafik Taste
     Portd.7 = 1
     Ausgabe1
     Portd.7 = 0
End If
'-----------------------------------------------------------------------------
' CLOAD"
If Key = 20 Then
    Key = 67
    Ausgabe
    Key = 76
    Ausgabe
    Key = 79
    Ausgabe
    Key = 65
    Ausgabe
    Key = 68
    Ausgabe
    Key = 34
    Ausgabe
    Key = 32
    Ausgabe
    Key = 34
End If

  'RUN
If Key = 21 Then
    Key = 82
    Ausgabe
    Key = 85
    Ausgabe
    Key = 78
    Ausgabe
    Key = 13
 End If

'CSAVE"
If Key = 22 Then
    Key = 67
    Ausgabe
    Key = 83
    Ausgabe
    Key = 65
    Ausgabe
    Key = 86
    Ausgabe
    Key = 69
    Ausgabe
    Key = 34
End If


'LIST
If Key = 23 Then
    Key = 76
    Ausgabe
    Key = 73
    Ausgabe
    Key = 83
    Ausgabe
    Key = 84
    Ausgabe
    Key = 13
End If


'BYE
If Key = 24 Then
    Key = 66
    Ausgabe
    Key = 89
    Ausgabe
    Key = 69
End If

'----------------------------------------------------------------------------
 'Control Taste und Taste A - Z


  If Key = 26 Then H = 1                                    ' Taste Strg merken
   For I = 65 To 90                                         ' Taste A bis Q gedrckt
      If H = 1 And Key = I Then                             'Ist Strg und Taste gedrckt
        Key = Key - 64                                      ' Ergibt Kode  01H - 11H
        H = 0                                               ' Taste wieder normal
      End If
   Next I

'-----------------------------------------------------------------------------

If Key = 255 Then
   Toggle Capslock
   Locate 1 , 1
   'If Capslock = 0 Then Lcd "Caps_Off"
   'If Capslock = 1 Then Lcd "Caps_On "
Else

If Key < 123 And Key > 95 And Capslock = 1 Then Reset Key.5


'Locate 2 , 1

'Lcd Key ; " " ; Chr(key) ; "    "

Kb_d0 = Key.0
Kb_d1 = Key.1
Kb_d2 = Key.2
Kb_d3 = Key.3
Kb_d4 = Key.4
Kb_d5 = Key.5
Kb_d6 = Key.6

Waitms 1
Set Kb_strobe
Waitms 80                                                   'Orginal 2
Reset Kb_strobe
Waitms 100


Reset Kb_d0
Reset Kb_d1
Reset Kb_d2
Reset Kb_d3
Reset Kb_d4
Reset Kb_d5
Reset Kb_d6

End If


End Sub


'--------------------------------------------------------------------------
' String ausgeben fr Funktionstasten
Sub Ausgabe

Kb_d0 = Key.0
Kb_d1 = Key.1
Kb_d2 = Key.2
Kb_d3 = Key.3
Kb_d4 = Key.4
Kb_d5 = Key.5
Kb_d6 = Key.6

Waitms 1
Set Kb_strobe
Waitms 50                                                   'Orginal 2
Reset Kb_strobe
Waitms 100


Reset Kb_d0
Reset Kb_d1
Reset Kb_d2
Reset Kb_d3
Reset Kb_d4
Reset Kb_d5
Reset Kb_d6

End Sub

'-----------------------------------------------------------------------------
' Fr RST
Sub Ausgabe1
 Waitms 1
 Set Kb_strobe
 Waitms 50                                                  'Orginal 2
 Reset Kb_strobe
 Waitms 100
End Sub
'-------------------------------------------------------------------------------

Keydata:

Data 0                                                      ' 000 Null
Data 16                                                     ' 001 F9  Zeichen normal
Data 0                                                      ' 002
Data 24                                                     ' 003 F5  BYE
Data 22                                                     ' 004 F3  CSAVE
Data 20                                                     ' 005 F1  CLOAD
Data 21                                                     ' 006 F2  RUN
Data 25                                                     ' 007 F12  Reset Taste
Data 0                                                      ' 008
Data 14                                                     ' 009 F10
Data 17                                                     ' 010 F8   Zeichen invers
Data 0                                                      ' 011 F6
Data 23                                                     ' 012 F4  LIST
Data 15                                                     ' 013 15  Tab
Data 94                                                     ' 014 ^   Pfeil oben
Data 0                                                      ' 015
Data 0                                                      ' 016
Data 0                                                      ' 017
Data 0                                                      ' 018
Data 0                                                      ' 019
Data 26                                                     ' 020 Strg L
Data 81                                                     ' 021 Q
Data 49                                                     ' 022 1
Data 0                                                      ' 023
Data 0                                                      ' 024
Data 0                                                      ' 025
Data 89                                                     ' 026 Y
Data 83                                                     ' 027 S
Data 65                                                     ' 028 A
Data 87                                                     ' 029 W
Data 50                                                     ' 030 2
Data 0                                                      ' 031
Data 0                                                      ' 032
Data 67                                                     ' 033 C
Data 88                                                     ' 034 X
Data 68                                                     ' 035 D
Data 69                                                     ' 036 E
Data 52                                                     ' 037 4
Data 51                                                     ' 038 3
Data 0                                                      ' 039
Data 0                                                      ' 040
Data 32                                                     ' 041 Leerschritt Space
Data 86                                                     ' 042 V
Data 70                                                     ' 043 F
Data 84                                                     ' 044 T
Data 82                                                     ' 045 R
Data 53                                                     ' 046 5
Data 0                                                      ' 047
Data 0                                                      ' 048
Data 78                                                     ' 049 N
Data 66                                                     ' 050 B
Data 72                                                     ' 051 H
Data 71                                                     ' 052 G
Data 90                                                     ' 053 Z
Data 54                                                     ' 054 6
Data 0                                                      ' 055
Data 0                                                      ' 056
Data 0                                                      ' 057
Data 77                                                     ' 058 M
Data 74                                                     ' 059 J
Data 85                                                     ' 060 U
Data 55                                                     ' 061 7
Data 56                                                     ' 062 8
Data 0                                                      ' 063
Data 0                                                      ' 064
Data 44                                                     ' 065 ,
Data 75                                                     ' 066 K
Data 73                                                     ' 067 I
Data 79                                                     ' 068 O
Data 48                                                     ' 069 0
Data 57                                                     ' 070 9
Data 0                                                      ' 071
Data 0                                                      ' 072
Data 46                                                     ' 073 .
Data 45                                                     ' 074 - und Ziffernblock
Data 76                                                     ' 075 L
Data 92                                                     ' 076 
Data 80                                                     ' 077 P
Data 126                                                    ' 078 
Data 0                                                      ' 079
Data 0                                                      ' 080
Data 0                                                      ' 081
Data 91                                                     ' 082 
Data 0                                                      ' 083
Data 93                                                     ' 084 
Data 92                                                     ' 085 
Data 0                                                      ' 086
Data 0                                                      ' 087
Data 255                                                    ' 088 CapsLock
Data 0                                                      ' 089
Data 13                                                     ' 090 Wagenrcklauf
Data 43                                                     ' 091 +
Data 0                                                      ' 092
Data 35                                                     ' 093 #
Data 0                                                      ' 094
Data 0                                                      ' 095
Data 0                                                      ' 096
Data 60                                                     ' 097 <
Data 0                                                      ' 098
Data 0                                                      ' 099
Data 0                                                      ' 100
Data 0                                                      ' 101
Data 95                                                     ' 102 95 BS Rckschritt DEL
Data 0                                                      ' 103
Data 0                                                      ' 104
Data 2                                                      ' 105
Data 0                                                      ' 106
Data 8                                                      ' 107 Pfeil links
Data 1                                                      ' 108 Pos1  Bild hoch
Data 0                                                      ' 109
Data 0                                                      ' 110
Data 0                                                      ' 111
Data 5                                                      ' 112 Einf
Data 4                                                      ' 113 Entf
Data 10                                                     ' 114  Pfeil runter
Data 53                                                     ' 115 5
Data 9                                                      ' 116  Pfeil rechts
Data 11                                                     ' 117  Pfeil hoch
Data 28                                                     ' 118 ESCAPE Break Taste
Data 0                                                      ' 119
Data 18                                                     ' 120 F11 Grafik Taste
Data 43                                                     ' 121 +
Data 6                                                      ' 122  Bild runter Kursor Anfang Zeile
Data 45                                                     ' 123 -
Data 42                                                     ' 124 *
Data 12                                                     ' 125 Bild hoch BS lschen Home
Data 3                                                      ' 126
Data 0                                                      ' 127
Data 0                                                      ' 128
Data 0                                                      ' 129
Data 0                                                      ' 130
Data 0                                                      ' 131 F7
Data 0                                                      ' 132
Data 0                                                      ' 133
Data 0                                                      ' 134
Data 0                                                      ' 135
Data 0                                                      ' 136
Data 0                                                      ' 137
Data 0                                                      ' 138
Data 0                                                      ' 139
Data 0                                                      ' 140
Data 0                                                      ' 141
Data 0                                                      ' 142
Data 0                                                      ' 143
Data 0                                                      ' 144
Data 0                                                      ' 145
Data 0                                                      ' 146
Data 0                                                      ' 147
Data 0                                                      ' 148
Data 113                                                    ' 149 p
Data 33                                                     ' 150 !
Data 0                                                      ' 151
Data 0                                                      ' 152
Data 0                                                      ' 153
Data 121                                                    ' 154 y
Data 115                                                    ' 155 s
Data 97                                                     ' 156 a
Data 119                                                    ' 157 w
Data 34                                                     ' 158 Anfhrungszeichen oben
Data 0                                                      ' 159
Data 0                                                      ' 160
Data 99                                                     ' 161 c
Data 120                                                    ' 162 x
Data 100                                                    ' 163 d
Data 101                                                    ' 164 e
Data 36                                                     ' 165 $
Data 64                                                     ' 166 @
Data 0                                                      ' 167
Data 0                                                      ' 168
Data 32                                                     ' 169 Leerschritt
Data 118                                                    ' 170 v
Data 102                                                    ' 171 f
Data 116                                                    ' 172 t
Data 114                                                    ' 173 r
Data 37                                                     ' 174 %
Data 0                                                      ' 175
Data 0                                                      ' 176
Data 110                                                    ' 177 n
Data 98                                                     ' 178 b
Data 104                                                    ' 179 h
Data 103                                                    ' 180 g
Data 122                                                    ' 181 z
Data 38                                                     ' 182 &
Data 0                                                      ' 183
Data 0                                                      ' 184
Data 108                                                    ' 185 l
Data 109                                                    ' 186 m
Data 106                                                    ' 187 j
Data 117                                                    ' 188 u
Data 47                                                     ' 189 /
Data 40                                                     ' 190 (
Data 0                                                      ' 191
Data 0                                                      ' 192
Data 59                                                     ' 193 ;
Data 107                                                    ' 194 k
Data 105                                                    ' 195 i
Data 111                                                    ' 196 o
Data 61                                                     ' 197 =
Data 41                                                     ' 198 )
Data 0                                                      ' 199
Data 0                                                      ' 200
Data 58                                                     ' 201 :
Data 45                                                     ' 202 -  '_
Data 108                                                    ' 203 l
Data 124                                                    ' 204 
Data 112                                                    ' 205 p
Data 63                                                     ' 206 ?
Data 0                                                      ' 207
Data 0                                                      ' 208
Data 0                                                      ' 209
Data 123                                                    ' 210 
Data 0                                                      ' 211
Data 125                                                    ' 212 
Data 96                                                     ' 213 `
Data 0                                                      ' 214
Data 0                                                      ' 215
Data 0                                                      ' 216
Data 0                                                      ' 217
Data 13                                                     ' 218 Wagenrcklauf
Data 42                                                     ' 219 *
Data 0                                                      ' 220
Data 39                                                     ' 221 '
Data 0                                                      ' 222
Data 0                                                      ' 223
Data 0                                                      ' 224
Data 62                                                     ' 225 >
Data 0                                                      ' 226
Data 0                                                      ' 227
Data 0                                                      ' 228
Data 8                                                      ' 229  Rckschritt
Data 95                                                     ' 230  Backspace mit Shift
Data 0                                                      ' 231
Data 0                                                      ' 232
Data 49                                                     ' 233  1 Ziffernblock
Data 0                                                      ' 234
Data 52                                                     ' 235  4 Ziffernblock
Data 55                                                     ' 236  7 Ziffernblock
Data 0                                                      ' 237
Data 0                                                      ' 238
Data 0                                                      ' 239
Data 48                                                     ' 240  0 Ziffernblock
Data 44                                                     ' 241  , Ziffernblock
Data 50                                                     ' 242  2 Ziffernblock
Data 53                                                     ' 243  5 Ziffernblock
Data 54                                                     ' 244  6 Ziffernblock
Data 56                                                     ' 245  8 Ziffernblock
Data 0                                                      ' 246
Data 0                                                      ' 247
Data 0                                                      ' 248
Data 43                                                     ' 249  + Ziffernblock
Data 51                                                     ' 250  3 Ziffernblock
Data 45                                                     ' 251  - Ziffernblock
Data 27                                                     ' 252  Druck
Data 57                                                     ' 253  9 Ziffernblock
Data 0                                                      ' 254
Data 0                                                      ' 255